mod libc_extern {
    unsafe extern "C" {
        pub fn malloc(amount: usize) -> *const u8;
        pub fn free(ptr: *const u8);
    }
}

pub fn malloc(amount: usize) -> *const u8 {
    unsafe { libc_extern::malloc(amount) }
}

pub fn free<T>(ptr: *const T) {
    unsafe { libc_extern::free(ptr as *const u8) }
}

pub fn new<T>() -> *mut T {
    malloc(std::mem::size_of::<T>()).cast::<T>().cast_mut()
}
