use std::fmt;

use crate::allocator;

#[repr(C)]
pub struct LogicLong {
    pub higher_int: i32,
    pub lower_int: i32,
}

impl LogicLong {
    pub fn new(higher_int: i32, lower_int: i32) -> &'static Self {
        unsafe {
            let instance = &mut *allocator::new::<Self>();
            instance.higher_int = higher_int;
            instance.lower_int = lower_int;
            instance
        }
    }

    pub fn set(&mut self, higher_int: i32, lower_int: i32) {
        self.higher_int = higher_int;
        self.lower_int = lower_int;
    }
}

impl fmt::Display for LogicLong {
    fn fmt(&self, f: &mut fmt::Formatter<'_>) -> fmt::Result {
        write!(f, "LogicLong({},{})", self.higher_int, self.lower_int)
    }
}
