mod account;
mod home;
mod sector;

pub use account::*;
pub use home::*;
pub use sector::*;

use crate::util::data_stream::ByteStream;

#[repr(C)]
pub struct PiranhaMessageVTable {
    finalizer_1: extern "C" fn(ptr: *const PiranhaMessage),
    finalizer_2: extern "C" fn(ptr: *const PiranhaMessage),
    encode: extern "C" fn(ptr: *const PiranhaMessage),
    decode: extern "C" fn(ptr: *const PiranhaMessage),
    pub get_service_node_type: extern "C" fn() -> i32,
    pub get_message_type: extern "C" fn() -> u16,
}

#[repr(C)]
pub struct PiranhaMessage {
    pub vtable: &'static PiranhaMessageVTable,
    pub version: i32,
    pub stream: ByteStream,
    pub proxy_session_id: i32,
}
