use std::mem::MaybeUninit;

use crate::ffi_util::import;

#[repr(C)]
pub struct LogicScrollMessageFactory {
    vtable: usize,
    is_udp_factory: bool,
}

impl LogicScrollMessageFactory {
    pub const RC4_KEY: &str = "fhsd6f86f67rt8fw78fw789we78r9789wer6re";

    pub fn new(is_udp_factory: bool) -> Self {
        import!(logic_scroll_message_factory_ctor(ptr: *const LogicScrollMessageFactory, is_udp: bool) -> () = 0x118F60 + 1);

        unsafe {
            let instance = MaybeUninit::zeroed().assume_init();
            logic_scroll_message_factory_ctor(&instance, is_udp_factory);
            instance
        }
    }
}
